# -*- coding: utf-8 -*-
"""
Created on Tue Feb 16 12:03:39 2021

Test KI import

@author: Laurin
"""

import pygame, sys, random,time

##### Es sind noch dieverse Debugmeldungen enthalten

####

from datetime import datetime
def Name_time(name):
    # datetime object containing current date and time
    now = datetime.now()
    # dd/mm/YY H:M:S
    new_name = str(name) +  "_" + now.strftime("%d/%m/%Y_%H_%M_%S")
    return new_name

print(Name_time("test"))



####

def Read_txt(Name):
    try:
        with open(Name) as fobj:
            text=fobj.read()
    except FileNotFoundError:
        text=None
    print(text)
    return text

def Remove_str_after_dot(string):
    for i in range(len(string)):
        if string[i]==".":
            return string[:i]
    return string

def Nummerate_Name(Name,Versuche=100, Endung=".txt"):
    Name=Remove_str_after_dot(Name)
    print(Name)
    try:
        with open(Name+Endung) as f:
            print("Finde_Name: ", Name+Endung,"Datei ist bereits vorhanden")
    except FileNotFoundError:
        Name= Name+Endung
        print("Finde_Name, Name: ", Name, "Datei ist noch nicht vorhanden")
        return Name
    for i in range(Versuche):
        New_Name=Name+"_"+str(i)+Endung
        print(New_Name)
        try:
            with open(New_Name) as f:
                print("Nummerate_Name: ", New_Name,"Datei ist bereits vorhanden")
        except FileNotFoundError:
            print("New_Name: ",New_Name)
            return New_Name
    raise Exception('''Nummerate_Name() hat nicht ausgereichtum einen noch nicht vorhandenen Dateinamen zu erzeugen. Waehle einen anderen Namen oder erhoehe die Versuche''')



#####



# WIP, Zeigt Text an
def draw_text(text,screen,y_pos = 5,x_pos = 5):
    font = pygame.font.SysFont("arial", 25)
    for line in text.splitlines():
        for pos in range(1, len(line)+1):
            text = font.render(line[:pos], 1, (255, 255, 255))
            screen.blit(text, (x_pos, y_pos))
            pygame.display.update()
            #time.sleep(0.02)
        y_pos += 25
        x_pos += 0

# Klasse der Feld-Sprites
class Feld(pygame.sprite.Sprite):
    def __init__(self,b,h,x,y,Nummer=[0,0],color=(255,255,255), Bestizer=0):
        super().__init__()
        self.image =pygame.Surface([b,h])
        self.image.fill(color)
        self.rect = self.image.get_rect()
        self.rect.topleft = [x,y]
        self.Nummer=Nummer
        self.Color=color
        self.Set=False
    def Feld_Update(self,G):
        self.Color=G.Player_color[G.Player+2]
        self.image.fill(self.Color)
        self.Set=True
        return

# Klasse der Linien-Sprites
class Linie(pygame.sprite.Sprite):
    def __init__(self,b,h,x,y,Nummer=[0,0],color=(255,255,255)):
        super().__init__()
        self.image =pygame.Surface([b,h])
        self.image.fill(color)
        self.rect = self.image.get_rect()
        self.rect.topleft = [x,y]
        self.Nummer=Nummer
        self.Color=color
        self.Set=False
    def Update(self):
        self.image.fill(self.Color)
        self.Set=True
        return

# --- Initialisierung ---
# - es wird ein Spielfeld mit der Höhe "h" und der Breite "b" erzeugt

# Initialisierung der Linien:
def Init_Linien(start_x,start_y,b,h,dicke,lang,Linien_gruppe):
    for i in range(h):
        for j in range(b):
            neue_linie = Linie(lang, dicke, start_x+(lang+dicke)*j, start_y+(lang+dicke)*i-dicke,[j,i*2])
            Linien_gruppe.add(neue_linie)
            neue_linie = Linie(dicke, lang, start_x+(lang+dicke)*j-dicke, start_y+(lang+dicke)*i,[j,i*2+1])
            Linien_gruppe.add(neue_linie)
        neue_linie = Linie(dicke, lang, start_x+(lang+dicke)*b-dicke, start_y+(lang+dicke)*i,[b,2*i+1])
        Linien_gruppe.add(neue_linie)
    for j in range(b):
        neue_linie = Linie(lang, dicke, start_x+(lang+dicke)*j, start_y+(lang+dicke)*h-dicke,[j,h*2])
        Linien_gruppe.add(neue_linie)

# Funktion um den Spielfeldrand zu deaktivieren
def Disable_Edges(b,h,Linien_gruppe,dis_Color=(100,100,100)):
    for i in range(b):
        Linie=Get_Linie(Linien_gruppe, [i,0])
        Linie.Color=dis_Color
        Linie.Update()
        Linie=Get_Linie(Linien_gruppe, [i,h*2])
        Linie.Color=dis_Color
        Linie.Update()
    for i in range(h):
        Linie=Get_Linie(Linien_gruppe, [0,i*2+1])
        Linie.Color=dis_Color
        Linie.Update()
        Linie=Get_Linie(Linien_gruppe, [b,i*2+1])
        Linie.Color=dis_Color
        Linie.Update()

# Felder Deaktivieren
def Diable_Feld(Feld_gruppe, Linien_gruppe, Game, Dict, Nummer,dis_Color_F=(150,150,150),dis_Color_L=(100,100,100)):
    F=Get_Feld(Feld_gruppe, Nummer)
    F.image.fill(dis_Color_F)
    F.Set=True
    Game.Diabled+=1
    for k in range(4):
        L=Dict[Nummer[0],Nummer[1],k]
        Linie=Get_Linie(Linien_gruppe, L)
        Linie.Color=dis_Color_L
        Linie.Update()
        print("Diabled Line: ",k, "  ", Linie.Set)
    


# Initialisierung der Felder:
def Init_Felder(start_x,start_y,b,h,dicke,lang,Feld_gruppe):
    for i in range(h):
        for j in range(b):
            neues_Feld = Feld(lang,lang,start_x+(lang+dicke)*j,start_y+(lang+dicke)*i,[j,i],(0,0,0))
            Feld_gruppe.add(neues_Feld)

# Initialisiert das Spielfeld
def Init_Spiel(start_x,start_y,b,h,dicke,lang,Linien_gruppe,Feld_gruppe):
    Init_Linien(start_x,start_y,b,h,dicke,lang,Linien_gruppe)
    Init_Felder(start_x,start_y,b,h,dicke,lang,Feld_gruppe)

# Es wird eine Zuordnug (als Dictionary) zwischen Linien und Feldern angelegt
def Init_Dict(b,h):
    Dict={}
    for i in range(h):
        for j in range(b):
            Dict[j,i,0]= [j,2*i]
            Dict[j,i,1]= [j+1,2*i+1]
            Dict[j,i,2]= [j,2*i+2]
            Dict[j,i,3]= [j,2*i+1]
    #print(Dict)
    return Dict

# Liefert eine Liste mit den Felder, die eine bestimmten Linie einthalten
def Dict_get(Dict, Nummer):
    f=[]
    for Feld, Linie in Dict.items():
        if Linie == Nummer:
            f.append(Feld)
            #print("Dict: Linie: ",Linie, "  Feld: ", Feld)
    return f

# Liefert das Linien-Objekt mit der gegebenen Nummer zurück
def Get_Linie(Linien_gruppe, Nummer):
    for L in Linien_gruppe:
        if L.Nummer == Nummer:
            return L

# Liefert das Feld-Objekt mit der gegebenen Nummer zurück
def Get_Feld(Feld_gruppe, Nummer):
    for F in Feld_gruppe:
        if F.Nummer == Nummer:
            return F

# Ändert den Status einer bestimmten Linie zu True, die Linie wurde "gestezt"
def Set_Linie(Linien_gruppe, Nummer):
    L=Get_Linie(Linien_gruppe, Nummer)
    L.Set=True
    
# Abfrage ob ein bestimmets Feld vollendet ist
def Check_Feld(Dict,Feld, Linien_gruppe):
    Set=[]
    for k in range(4):
        L=Dict[Feld[0],Feld[1],k]
        Linie=Get_Linie(Linien_gruppe, L)
        #print(Linie.Set)
        #print("Check_Feld: ",k, "  ", Linie.Set)
        if Linie.Set==False:
            return False
    return True
        


# Das Game-Objekt speichert den Spielstand
class Game_Object():
    def __init__(self):
        super().__init__()
        self.Player=0
        self.Player_color=[(100,230,150),(170,100,230),(50,170,100),(100,50,170)]
        self.Player_Punkte=[0,0]
        self.has_changed=False
        self.Counter=1
        self.Data=[]
    def Init_Data(self,b,h):
        for y in range(2*h+1):
            self.Data.append([])
            for x in range(b+1*(y%2)):
                self.Data[y].append(0)
        #print(self.Data)
    def Update_Data(self,Linie):
        #print(Linie.Nummer)
        N=Linie.Nummer
        self.Data[N[1]][N[0]]=int(Linie.Set)
        #print(self.Data)
        
    def Change_Player(self):
        if self.Player==0:
            self.Player=1
        else:
            self.Player=0
    def Set_Linie(self, Nummer, Dict, Linien_gruppe,Feld_gruppe):
        Set_Linie(Linien_gruppe, Nummer)
        Felder=Dict_get(Dict, Nummer)
        C=False
        for Feld in Felder:
            C=Check_Feld(Dict,Feld, Linien_gruppe) or C
            Check=Check_Feld(Dict,Feld, Linien_gruppe)
            #print(Check)
            if Check:
                F=Get_Feld(Feld_gruppe, [Feld[0],Feld[1]])
                F.Feld_Update(self)
                self.Player_Punkte[self.Player] +=1
                self.has_changed=True
        #print("Feld: ",Feld)
        if not C:
            self.Change_Player()
            return
    def Count_up(self):
        self.Counter+=1
    def Check_Win(self,b,h):
        #print("_______________________")
        a=False
        Gewinner=0
        if self.Player_Punkte[0]+self.Player_Punkte[1]==b*h:
            if self.Player_Punkte[0]>self.Player_Punkte[1]:
                Gewinner=1
            else:
                Gewinner=2
            a=True
        
        Info=[a,Gewinner]
        #print("---Info ", self.Counter," : ", Info)
        return Info


# erzeugt einen zufälligen rgb-Frabwert (für Testzwecke)
def random_color(r=(0,255),g=(0,255),b=(0,255)):
    red=random.randint(r[0],r[1])
    green=random.randint(g[0],g[1])
    blue=random.randint(b[0],b[1])
    color=(red,green,blue)
    return color


def Koordinaten_berechnen(b,h,Index):
    counter = 0
    for i in range(2*h + 1):
        for j in range(b + 1):
            if i % 2 == 0:
                if j < b:
                    counter += 1
            else:
                counter += 1
            if counter == Index:
                Koordinaten = [j,i]
                return Koordinaten

def liste_2D_zu_1D(Liste):
    neue_liste =[]
    for i in range(len(Liste)):
        for j in range(len(Liste[i])):
            neue_liste.append(Liste[i][j])
    return neue_liste


#Hauptprogramm
def Main_Spieler_gegen_KI(b, h, net, width = 1280, height = 720, Edges_not_playable=False):
    
    print("---Spieler gegen KI---")
    
    G=Game_Object()
    BG_Gruppe=pygame.sprite.Group()
    BG=Init_Felder(0,0,1,1,170,170,BG_Gruppe)

    
    Linien_gruppe= pygame.sprite.Group()
    Feld_gruppe= pygame.sprite.Group()
    clock = pygame.time.Clock()
    
    
    screen = pygame .display. set_mode((width,height))
    #Init_Linien(100,100,5,3,10,100,Linien_gruppe)
    Init_Spiel(100,100,b,h,10,100,Linien_gruppe,Feld_gruppe)
    Dict=Init_Dict(b,h)
    if Edges_not_playable:
        Disable_Edges(b,h,Linien_gruppe)
    #Player=0
    #Player_color=[(100,230,150),(170,100,230)]
#######################
    G.Init_Data(b,h)
    #G.Update_Data(Linien_gruppe)
    
    Spiel_am_laufen = True
    
    while Spiel_am_laufen:
        if G.Player == 0:
            for event in pygame.event.get():
                if event.type == pygame.QUIT:
                    pygame.quit()
                    sys.exit()
                if event.type == pygame.MOUSEBUTTONDOWN:
                    mouse_pos=pygame.mouse.get_pos()
                    for Linie in Linien_gruppe:
                        if Linie.rect.collidepoint(mouse_pos):##########################################
                            print(Linie.Nummer)
                            Dict_get(Dict, Linie.Nummer)
                            if not Linie.Set:
                                Linie.Color=G.Player_color[G.Player]
                                G.Set_Linie(Linie.Nummer, Dict, Linien_gruppe,Feld_gruppe)
                                G.Count_up()
                                #Player=Change_Player(Player)
                                #Linie.Nummer
                                Linie.Update()
                                G.Update_Data(Linie)#####
                                print ('yay!')
                    for Feld in Feld_gruppe:
                        if Feld.rect.collidepoint(mouse_pos):
                            print(Feld.Nummer)
        
        elif G.Player == 1:
            Spielfeld = tuple(liste_2D_zu_1D(G.Data))
        
            Output = net.activate(Spielfeld)#funktion für eingabe der KI usw...
            
            for i in range(len(Output)):
                if Spielfeld[i]==1:
                    Output[i]=-10000

            
            Eingabe_index = Output.index(max(Output)) + 1
            Eingabe = Koordinaten_berechnen(b,h,Eingabe_index)
            
            print("Debug: KI "+ str(G.Player) + " Index: "+str(Eingabe_index)+"  Eingabe: "+str(Eingabe))
            
            Linie = Get_Linie(Linien_gruppe, Eingabe)
            
            if Linie.Set:
                #ge[G.Player].fitness -= 10000
                print("---Ende nach " + str(G.Counter) + " Zügen.")
                print("KI " + str(G.Player) + " hat ein falsches Feld gewählt")
                print("Die Eingabe war: " , Eingabe, ", Index: ", Eingabe_index, ", Wert: ", max(Output))
                print(G.Data)
                print(Output)
                Spiel_am_laufen = False
                pygame.display.flip()
                Linien_gruppe.draw(screen)
                Feld_gruppe.draw(screen)
                #return G.Counter
            
           # ge[G.Player].fitness += 20
            Linie.Color=G.Player_color[G.Player]
            G.Set_Linie(Linie.Nummer, Dict, Linien_gruppe,Feld_gruppe)
            G.Count_up()
            Linie.Update()
            G.Update_Data(Linie)
        
        if G.has_changed:
            
            print("Spieler 1:  "+str(G.Player_Punkte[0])+"\n"+"Spieler 2:  "+str(G.Player_Punkte[1]))
            G.has_changed=False
            BG_Gruppe.draw(screen)
            draw_text("Spieler 1:  "+str(G.Player_Punkte[0])+"\n"+"Spieler 2:  "+str(G.Player_Punkte[1]),screen)
            if G.Check_Win(b,h)[0]:
                if G.Player_Punkte[0]!=G.Player_Punkte[1]:
                    draw_text("Spieler "+str(G.Check_Win(b,h)[1])+" hat  mit "+str(G.Player_Punkte[G.Check_Win(b,h)[1]-1])+" Punkten gewonnen!",screen, 5,200)
                else:
                    draw_text("Unentschieden",screen,5,200)
                Spiel_am_laufen = False
                
        pygame.display.flip()
        #screen.blit(background,(0,0))
        #Linien_gruppe.Update()
        Linien_gruppe.draw(screen)
        Feld_gruppe.draw(screen)
        clock.tick(60)
    print("Spiel ist zuende")
    pygame.display.flip()
    Linien_gruppe.draw(screen)
    Feld_gruppe.draw(screen)
    time.sleep(5)
    pygame.quit()
    return
        
        
if __name__=='__main__': 
    
    import pickle
    import neat 
    
    pygame.font.init()
    
    name = input("Bitte gib den Namen der KI-Datei ein: ")
    pickle_in = open(name, "rb")
    net = pickle.load(pickle_in)
    try:
        Main_Spieler_gegen_KI(4, 4, net)
    except Exception as e:
        print(e)        